/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.enums.EnumPersonmodulerole;
import de.ship.db.tables.records.TCorePersonAttrRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Identity;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCorePersonAttr extends TableImpl<TCorePersonAttrRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_person_attr</code>
     */
    public static final TCorePersonAttr T_CORE_PERSON_ATTR = new TCorePersonAttr();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCorePersonAttrRecord> getRecordType() {
        return TCorePersonAttrRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_person_attr.lastchange</code>.
     */
    public final TableField<TCorePersonAttrRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("CURRENT_TIMESTAMP"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_person_attr.pk</code>.
     */
    public final TableField<TCorePersonAttrRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_core_person_attr.fk_usnr</code>.
     */
    public final TableField<TCorePersonAttrRecord, Integer> FK_USNR = createField(DSL.name("fk_usnr"), SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_core_person_attr.contact_mail</code>.
     */
    public final TableField<TCorePersonAttrRecord, String> CONTACT_MAIL = createField(DSL.name("contact_mail"), SQLDataType.CLOB.defaultValue(DSL.field(DSL.raw("''::text"), SQLDataType.CLOB)), this, "");

    /**
     * The column <code>common_dd.t_core_person_attr.module_affiliation</code>.
     */
    public final TableField<TCorePersonAttrRecord, String> MODULE_AFFILIATION = createField(DSL.name("module_affiliation"), SQLDataType.CLOB.defaultValue(DSL.field(DSL.raw("''::text"), SQLDataType.CLOB)), this, "");

    /**
     * The column <code>common_dd.t_core_person_attr.module_role</code>.
     */
    public final TableField<TCorePersonAttrRecord, EnumPersonmodulerole> MODULE_ROLE = createField(DSL.name("module_role"), SQLDataType.VARCHAR.asEnumDataType(EnumPersonmodulerole.class), this, "");

    private TCorePersonAttr(Name alias, Table<TCorePersonAttrRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCorePersonAttr(Name alias, Table<TCorePersonAttrRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_person_attr</code> table
     * reference
     */
    public TCorePersonAttr(String alias) {
        this(DSL.name(alias), T_CORE_PERSON_ATTR);
    }

    /**
     * Create an aliased <code>common_dd.t_core_person_attr</code> table
     * reference
     */
    public TCorePersonAttr(Name alias) {
        this(alias, T_CORE_PERSON_ATTR);
    }

    /**
     * Create a <code>common_dd.t_core_person_attr</code> table reference
     */
    public TCorePersonAttr() {
        this(DSL.name("t_core_person_attr"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TCorePersonAttrRecord, Integer> getIdentity() {
        return (Identity<TCorePersonAttrRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCorePersonAttrRecord> getPrimaryKey() {
        return Keys.PK_CORE_PERSON_ATTR;
    }

    @Override
    public List<UniqueKey<TCorePersonAttrRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_CORE_USNR);
    }

    @Override
    public TCorePersonAttr as(String alias) {
        return new TCorePersonAttr(DSL.name(alias), this);
    }

    @Override
    public TCorePersonAttr as(Name alias) {
        return new TCorePersonAttr(alias, this);
    }

    @Override
    public TCorePersonAttr as(Table<?> alias) {
        return new TCorePersonAttr(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCorePersonAttr rename(String name) {
        return new TCorePersonAttr(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCorePersonAttr rename(Name name) {
        return new TCorePersonAttr(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCorePersonAttr rename(Table<?> name) {
        return new TCorePersonAttr(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCorePersonAttr where(Condition condition) {
        return new TCorePersonAttr(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCorePersonAttr where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCorePersonAttr where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCorePersonAttr where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCorePersonAttr where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCorePersonAttr where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCorePersonAttr where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCorePersonAttr where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCorePersonAttr whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCorePersonAttr whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
